/**
 * Cashboard Timer copyright 2007 Subimage, LLC.
 *
 * No portion of this code may be duplicated or reproduced in any form.
 *
 */
var gTimerActive = false;
var gTimerInterval = null;
var gFormShown = false;
var gFrontShown = true;
var gCanAddEntry = false;

var gDebugMode = false;

// Buttons
var gInfoButton;
var gDoneButton;

/**
 * Widget initialization function.
 * Runs on body load.
 */
function init() {
	if (window.widget) {
	  //widget.onshow = handleWidgetShown;
	  //widget.onhide = handleWidgetHidden;		
		window.collapsedWidth = 344;
		window.collapsedHeight = 100;
		window.expandedWidth = 344;
		window.expandedHeight = 330;		
		window.prefsWidth = 344;
		window.prefsHeight = 400;

		window.resizeTo(window.collapsedWidth, window.collapsedHeight);
		gCurrentHeight = window.collapsedHeight;
		
		// If this is the first time the widget is added, make sure
		// to show prefs off the bat. (Or not all prefs set...)
		if (!prefsAreSet()) {
			showPrefs();
		}
	}
	
	// Setup buttons
  gInfoButton = new AppleInfoButton($("info_button"), $("front"), "white", "white", showPrefs);
	
	// Make sure users can only put digits into the time box
	Event.observe($('timer_content'), 'keyup', preventWeirdInput, false);
}

// Only allows digit input to the hours box.
function preventWeirdInput(e) {
	// allow passing in of object or event
	var source = Event.element(e);
	if (source == null) {
		source = e;
	}
	// Only allow chars 0-9.:
	var regexp = /[^0-9.:]/ig;
	if (source.value.match(regexp)) {
	  source.value = source.value.replace(regexp, "");
  }
}


function getSel() {
  win = window;  
	var txt = '';
	if (win.getSelection) {
		txt = win.getSelection();
	} else if (win.document.getSelection) {
		txt = win.document.getSelection();
	} else if (win.document.selection) {
		txt = win.document.selection.createRange().text;
	} else { return; }
	return txt;
}


// DROPDOWNS ==================================================================

/**
 * Gets lists of projects from server
 */
function getProjectDrop() {
	$('project_msg').show();
	$('project_drop').hide();
	$('project_msg').innerHTML = "Getting projects...";
	// Task msg needs to show too...
	$('task_msg').show();
	$('task_drop').hide();
	$('task_msg').innerHTML = "&nbsp;";
	// Disable add button until we know we have projects and tasks
	disableForm();
	apiCall('projects', fillProjectDrop);
}

// Fills project drop down
function fillProjectDrop(req) {
	projects = XMLParse.xml2ObjArray(req.responseXML, 'project');
	drop = $('project_drop');
	// remove all current options
	while (drop.firstChild) {
	  drop.removeChild(drop.firstChild);
	}
	
	msg_box = $('project_msg');
	
	if (projects.length == 0) {
		msg_box.innerHTML = "You aren't assigned to any projects."
	} else {
		msg_box.innerHTML = "";
		msg_box.hide();
		drop.show();
		// add new options...
		projects.each(function(project){
			option = document.createElement("option");
			option.value = project.id;
			option_name = project["client-name"] + " - " + project.name;
			// Truncate so drop doesn't overlap
			option.innerHTML = option_name.truncate(40);
			drop.appendChild(option);
		});	
	}
	
	// Now fill the task dropdown!
	changeProjectDrop();
}
/**
 * Handles change of project drop down.
 */
function changeProjectDrop() {
	drop = $('project_drop')
	var selected = drop.options[drop.selectedIndex];
	apiCall('tasks/' + selected.value, fillTaskDrop);
	$('task_msg').show();
	$('task_drop').hide();
	$('task_msg').innerHTML = "Getting tasks..."
}

/**
 * Gets lists of tasks from server
 */
function fillTaskDrop(req) {
	tasks = XMLParse.xml2ObjArray(req.responseXML, 'line-item');
	drop = $('task_drop');
	// remove all current options
	while (drop.firstChild) {
	  drop.removeChild(drop.firstChild);
	}
	
	msg_box = $('task_msg')
	
	if (tasks.length == 0) {
		msg_box.innerHTML = "No tasks for this project."
		disableForm();
	} else {
		enableForm();
		drop.show();
		msg_box.hide();
		// add new options...
		tasks.each(function(task){
			option = document.createElement("option");
			option.value = task.id;
			// Set up display string
			if (task.description) { 
				display_str = task.title + " - " + task.description;
			} else {
				display_str = task.title;
			}
			// Truncate so drop doesn't overlap
			option.innerHTML = display_str.truncate(40);
			drop.appendChild(option);
		});
	}

}

// PREFS ======================================================================

/**
 * Lets us know...
 */
function prefsAreSet() {
	return (Preference.get('subdomain') && Preference.get('email') && Preference.get('password'));
}

/**
 * Show back / prefs pane
 */ 
function showPrefs() {
	var front = $("front");
	var back = $("back");
	
	if (window.widget) {
		// set values from preferences
		$('subdomain').value = '';
		$('email').value = '';
		$('password').value = '';
		
		if (Preference.get('subdomain')) $('subdomain').value = Preference.get('subdomain');
		if (Preference.get('email')) $('email').value = Preference.get('email');
		if (Preference.get('password')) $('password').value = Preference.get('password');
		
		window.resizeTo(window.prefsWidth, window.prefsHeight);

		widget.prepareForTransition("ToBack");				
	}
	
	front.style.display="none";
	back.style.display="block";
	
	$('subdomain').focus();
	
	if (window.widget) setTimeout('widget.performTransition();', 0);
	gFrontShown = false;
}

/**
 * Show front panel
 */
function hidePrefs() {
	// Make sure prefs are set & valid before allowing the flip
	if (!prefsAreSet()) {
		showAjaxMessage("Please fill in all fields.");
		$('subdomain').focus();
		return;
	}
	
	var front = $("front");
	var back = $("back");
	
	if (window.widget) {
		if (gFormShown == true) {
			window.resizeTo(window.expandedWidth, window.expandedHeight);
		} else {
	  	window.resizeTo(window.collapsedWidth, window.collpasedHeight);
		}
	}
	
	if (window.widget) widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";


	if (window.widget) setTimeout('widget.performTransition();', 0);
	gFrontShown = true;
	hideAjaxMessage();
	// Refill project drop-down
	getProjectDrop();
}

/**
 * Saves preferences before hiding the prefs pane.
 *
 */
function savePrefs() {
	showAjaxMessage("Checking login info...");

	if (window.widget) {
	  Preference.set('subdomain', $('subdomain').value);
	  Preference.set('email', $('email').value);
	  Preference.set('password', $('password').value);
	}
	
	apiCall('projects', hidePrefs)
}


// ENTRY FORM ======================================================================

function disableForm() {
	gCanAddEntry = false;
	$('add_button').style.backgroundImage = "url(images/add-button-disabled.png)";
}

function enableForm() {
	gCanAddEntry = true;
	$('add_button').style.backgroundImage = "url(images/add-button.png)";
}

/**
 * Add the time entry!
 *
 * Only adds if a task is selected, to cut back on errors.
 */
function addEntry() {
	// Don't let em add an entry if there's no task selected.
	if (gCanAddEntry == false) { return; }

	// Else get on with the damn show.
	stopTimer();

	prj_drop = $('project_drop')
	project_id = prj_drop.options[prj_drop.selectedIndex].value;
	
	task_drop = $('task_drop')
	task_id = task_drop.options[task_drop.selectedIndex].value;
		
	params = "project_id=" + project_id;
	params = params + "&task_id=" + task_id;
	params = params + "&minutes=" + timer_content.value;
	params = params + "&notes=" + encodeURIComponent($('notes').value);
	
	apiCall('log_time', addEntrySuccess, params);
}

/**
 * Runs when entry is added.
 */
function addEntrySuccess() {
	// Reset timer
	resetTimer();
	// Reset notes
	$('notes').value = "";
	// Hide form
	toggleForm();
}

/**
 * Toggles the display of the form drawer...
 */
function toggleForm() {
	if (gFormShown == false) {
		// Grab project & task drops...
		getProjectDrop();
		//
		$('log_button').style.backgroundImage = "url(images/cancel.png)";
		//$('log_form').style.display = "block";
		if (window.widget) window.resizeTo(window.expandedWidth, window.expandedHeight);
		new Effect.Appear($("log_form"));
	} else {
		$('log_button').style.backgroundImage = "url(images/log-time.png)";
		//$('log_form').style.display = "none";
  	if (window.widget) window.resizeTo(window.collapsedWidth, window.collpasedHeight);
		new Effect.Fade($("log_form"));
	}
	gFormShown = !gFormShown;
}

// TIMER ======================================================================

/**
 * Starts/stops the timer based on the gTimerActive var.
 */
function toggleTimer() {
	// Start timer...
	if (gTimerActive == false) {
		startTimer();
	// Stop timer...	
	} else {
		stopTimer();
	}
}

/**
 * Resets the timer to 0.
 */
function resetTimer() {
	$('timer_content').value = formatSeconds(0);
	// Show effect
	new Effect.Pulsate($("timer_content"), {pulses: 1, duration: .5});
	// Make sure opacity is 100% because the pulsate fucks it up sometimes
	window.setTimeout("$('timer_content').style.opacity=1;", 600);
}

/**
 * Starts JS timer for hours/minutes
 */
function startTimer() {
	// Set styles for active clock
	$('timer').style.backgroundImage = "url(images/timer-active.png)";
	$('timer_content').style.color = "#1d441d";
	$('play_ctl').style.backgroundImage = "url(images/pause-idle.png)";
	// Start timer
	gTimerInterval = setInterval('incrementTimer();', 1000);
	gTimerActive = true;
	new Effect.Pulsate($("timer_content"), {pulses: 1, duration: .5});
}

function incrementTimer() {
	var timer_content = $('timer_content');
	timer_content.value = formatSeconds(stringToSeconds(timer_content.value)+1);
}

/**
 * Stops JS timer
 */
function stopTimer() {
	// Reset styles for inactive clock
	$('timer').style.backgroundImage = "";
	$('timer_content').style.color = "";
	$('play_ctl').style.backgroundImage = "url(images/play-idle.png)";
	// Stop timer
	clearInterval(gTimerInterval);
	gTimerActive = false;
	new Effect.Pulsate($("timer_content"), {pulses: 1, duration: .5});
}

/**
 * Handles mouseover for refresh icon
 */
function mouseOverRefresh() {
	$('refresh_ctl').style.backgroundImage = "url(images/refresh-hover.png)";
}
function mouseOutRefresh() {
	$('refresh_ctl').style.backgroundImage = "url(images/refresh-idle.png)";
}

/**
 * Handles mouseover for play/pause icon
 */
function mouseOverPlay() {
	if (gTimerActive == true) {
		$('play_ctl').style.backgroundImage = "url(images/pause-hover.png)";	
	} else {
		$('play_ctl').style.backgroundImage = "url(images/play-hover.png)";	
	}
}
function mouseOutPlay() {
	if (gTimerActive == true) {
		$('play_ctl').style.backgroundImage = "url(images/pause-idle.png)";
	} else {
		$('play_ctl').style.backgroundImage = "url(images/play-idle.png)";	
	}
}

// UTILS ======================================================================

/**
 * Takes H:M:S string and converts to seconds.
 */
function stringToSeconds(value) {
	if (value == null || value == '') { return 0; }
	var hours = 0;
	var minutes = 0;
	var seconds = 0;
	if (value.indexOf(':') != -1) {
		var values = value.split(':');
		var hours = parseInt(values[0], 10);
		var minutes = parseInt(values[1], 10);
		if (values.length >= 3) {
			var seconds = parseInt(values[2], 10);
		}
	} else {
		minutes = value;
	}
	if (isNaN(hours)) { hours = 0; }
	if (isNaN(minutes)) { minutes = 0; }
	if (isNaN(seconds)) { seconds = 0; }
	return parseInt((((hours*60) + minutes) * 60) + seconds, 10);
}

/**
 * Takes seconds and converts to H:M:S string.
 */
function formatSeconds(value) {
	value = parseInt(value,10);

	if (value == null || value == 0) { return "00:00:00"; }
	
	var hours = Math.floor(value/3600);
	var mins = Math.floor(value/60 - (hours*60));
	var secs = Math.floor(value - hours * 3600 - mins * 60);

	// Pad last zeros..
	hours = new String(hours);
	if (hours.length == 1) {
		hours = "0" + hours;
	}

	// Pad last zeros..
	mins = new String(mins);
	if (mins.length == 1) {
		mins = "0" + mins;
	}
	
	// Pad last zeros..
	secs = new String(secs);
	if (secs.length == 1) {
		secs = "0" + secs;
	}
	
	return hours + ":" + mins + ":" + secs;
}

/**
 * Shows debug message...
 */
function showDebugMsg(msg) {
	if (gDebugMode == true) {
		$('debug_message').innerHTML = msg;
		$('debug_message').show();
		window.resizeTo(window.expandedWidth, window.expandedHeight);
	}
}

/**
 * Shows AJAX response message depending on what mode we're in
 */
function showAjaxMessage(msg) {
	var msg_container;
	if (gFrontShown == true) {
		msg_container = $("front_message");
	} else {
		msg_container = $("back_message");
	}
	msg_container.innerHTML = msg;
	msg_container.show();
}

function hideAjaxMessage() {
	$("front_message").innerHTML = ""
	$("front_message").hide();
	$("back_message").innerHTML = ""
	$("back_message").hide();
}

// This code was written by Tyler Akins and has been placed in the
// public domain.  It would be nice if you left this header intact.
// Base64 code from Tyler Akins -- <a href="http://rumkin.com">http://rumkin.com</a>
function encode64(input) {
   var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
   var output = "";
   var chr1, chr2, chr3;
   var enc1, enc2, enc3, enc4;
   var i = 0;

   do {
         chr1 = input.charCodeAt(i++);
         chr2 = input.charCodeAt(i++);
         chr3 = input.charCodeAt(i++);

         enc1 = chr1 >> 2;
         enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
         enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
         enc4 = chr3 & 63;

         if (isNaN(chr2)) {
                 enc3 = enc4 = 64;
         } else if (isNaN(chr3)) {
                 enc4 = 64;
         }

         output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) +
         keyStr.charAt(enc3) + keyStr.charAt(enc4);
   } while (i < input.length);

   return output;
}

/**
 * Executes a get request on CB.
 */
function apiCall(action, callback, otherParams) {
	if (gDebugMode == true) {
		url = "http://" + Preference.get("subdomain") + ".localhost.i:3000/api/" + action;		
	} else {
		url = "https://" + Preference.get("subdomain") + ".cashboardapp.com/api/" + action;
	}

	
	params = "email="+ Preference.get("email") +"&password="+ Preference.get("password");
	if (otherParams != null) {
		params = params + "&" + otherParams;
	}
	
	var opts = {
		method: 'post',
		
		requestHeaders: [
			"Cache-Control", "no-cache",
			"Pragma", "no-cache",
			"Accept", "application/xml",
			"Content-Type", "application/xml"
		],
		
		parameters: params,
		
		// Handle errors
		onFailure: function(t) { showAjaxMessage(t.responseText) },

		/*
		onLoading: function(t) { 
			$('loading').hide();
			new Effect.Appear($('loading'), {duration: 0.5});
		},
		*/
		/*
		onComplete: function(t) { 
			//EventSelectors.start(Rules);
		},
		*/
		onSuccess: callback.bind(this)
	};
	
	new Ajax.Request(url, opts);	
}